import java.lang.Math;
import java.util.StringTokenizer;


class Brain extends Thread
{
	public rogi2		m_rogi2;			
	public Memory		m_memory;		
	public char		m_side;
	public char		o_side;
	public String		m_team, m_playMode;
	public int		m_number;
	public int		m_time;
	public int		local_goals;
	public int		visitant_goals;
	public boolean 		m_timeOver;
	public Player		player;
	public int 		nothing;

	public Brain(rogi2 r2, String team, char side, int number, String playMode, int goals1, int goals2)
	{
		m_timeOver = false;
		m_rogi2 = r2;
		m_side = side;
		m_number = number;
		m_team = team;
		m_memory = new Memory(m_team, m_number, m_side);
		if (m_side == 'l') o_side='r';
		else o_side='l';
		m_playMode = playMode;
		m_time = 0;
		local_goals = goals1;
		visitant_goals = goals2;
		nothing = 0;

		AssignPlayer();
	}

	public void AssignPlayer()
	{
		switch (m_number)
		{
			case 1:  player = new One(m_rogi2, m_memory, m_side, m_playMode, m_team, m_number); break;
			case 2:  player = new Two(m_rogi2, m_memory, m_side, m_playMode, m_team, m_number); break;
			case 3:  player = new Three(m_rogi2, m_memory, m_side, m_playMode, m_team, m_number); break;
			case 4:  player = new Four(m_rogi2, m_memory, m_side, m_playMode, m_team, m_number); break;
			case 5:  player = new Five(m_rogi2, m_memory, m_side, m_playMode, m_team, m_number); break;
			case 6:  player = new Six(m_rogi2, m_memory, m_side, m_playMode, m_team, m_number); break;
			case 7:  player = new Seven(m_rogi2, m_memory, m_side, m_playMode, m_team, m_number); break;
			case 8:  player = new Eight(m_rogi2, m_memory, m_side, m_playMode, m_team, m_number); break;
			case 9:  player = new Nine(m_rogi2, m_memory, m_side, m_playMode, m_team, m_number); break;
			case 10: player = new Ten(m_rogi2, m_memory, m_side, m_playMode, m_team, m_number); break;
			case 11: player = new Eleven(m_rogi2, m_memory, m_side, m_playMode, m_team, m_number); break;
		}
	}

	public void TakeReactiveDecision()
	{
		if (m_memory.wait == false) player.TakeReactiveDecision(m_memory, m_playMode);
	}

	public void TakeDeliberativeDecision()
	{
		if (m_memory.wait == false) player.TakeDeliberativeDecision();
	}

	public void UpdateMemory(SeeInfo info)
	{
		if (info != null) 
		{
			m_time = info.m_time;
			nothing = 0;
		}
		else 
		{
			if (m_playMode.compareTo("before_kick_off")!=0) m_time++;

			nothing++;
			if (nothing > 100)
			{
				System.out.println(" ");
				System.out.println("PLAYER "+m_number+" : connection closed (time out).");
				System.exit(1);
			}
		}

		m_memory.see(info, m_time);
	}

	public void sense_body(SenseBodyInfo info)
	{
		m_memory.sense_body(info);
	}

	public void hear(HearInfo info)
	{
		m_memory.hear(info);
	}

	public void hear(int time, String message)
	{						 
		if (message.compareTo("time_over") == 0) 
		{
			System.out.println(" ");
			System.out.println("TIME OVER !!");
			System.exit(1);
		}
/* active it if you interest to make changes in the half time
		else if (message.compareTo("half_time") == 0) 
		{
			System.out.println(" ");
			System.out.println("HALF TIME !!");
			System.exit(1);
		}
*/		else if (message.compareTo("play_on") == 0) m_playMode=message;
		else if (message.compareTo("before_kick_off") == 0) m_playMode=message;
		else if (message.compareTo("kick_off_l") == 0) m_playMode=message;
		else if (message.compareTo("kick_off_r") == 0) m_playMode=message;
		else if (message.compareTo("kick_in_l") == 0) m_playMode=message;
		else if (message.compareTo("kick_in_r") == 0) m_playMode=message;
		else if (message.compareTo("free_kick_l") == 0) m_playMode=message;
		else if (message.compareTo("free_kick_r") == 0) m_playMode=message;
		else if (message.compareTo("corner_kick_l") == 0) m_playMode=message;
		else if (message.compareTo("corner_kick_r") == 0) m_playMode=message;
		else if (message.compareTo("goal_kick_l") == 0) m_playMode=message;
		else if (message.compareTo("goal_kick_r") == 0) m_playMode=message;
		else if (message.compareTo("goal_l") == 0) m_playMode=message;
		else if (message.compareTo("goal_r") == 0) m_playMode=message;
		else if (message.compareTo("goal_"+m_side+"_"+(local_goals+1)) == 0) 
		{
			m_playMode="goal_"+m_side;
			local_goals++;
		}
		else if (message.compareTo("goal_"+o_side+"_"+(visitant_goals+1)) == 0) 
		{
			m_playMode="goal_"+o_side;
			visitant_goals++;
		}
	}
}