class CooperativeWorldPerception
{
	float P[][];
	float N;
	Player m_player;

	Functions f = new Functions();

	public CooperativeWorldPerception(Player player)
	{
		m_player = player;
		N = (float)0.5;

		AssignInitialPrestige();
	}

	public ListPossibleActions DeliberativeDecision(ListPossibleActions others, ListPossibleActions me)
	{
		/*****************************************************************/
		/*************   INCOMPATIBILITIES MANAGEMENT   ******************/
		/*****************************************************************/

		PossibleAction m_bestaction = me.MoreCertainty(m_player.m_number);

		int p=1;
		while (p<=11)
		{
			if (p != m_player.m_number)
			{
				PossibleAction o_bestaction = others.MoreCertainty(p); 

				if (o_bestaction != null)
				{
					if (Incompatibility(m_bestaction, o_bestaction))
					{
						if (MustChange(m_bestaction, o_bestaction))
						{
//System.out.println("canvi opinio");
							// CHANGE MY DECISION
							me.removeAction(m_bestaction.action, m_player.m_number);// I ignore the most certainty action
							m_bestaction = me.MoreCertainty(m_player.m_number);	// I take the next more certainty action
							p = 0;
						}
					}
				}
			}
			p++;
		}

		return me;
	}

	public boolean Incompatibility(PossibleAction m_bestaction, PossibleAction o_bestaction)
	{
		if ((m_bestaction.action == Actions.KICK_GOAL)
		  ||(m_bestaction.action == Actions.CATCH_BALL)
		  ||(m_bestaction.action == Actions.CONTROL_BALL)
		  ||(m_bestaction.action == Actions.DRIBBLE)
		  ||((m_bestaction.action == Actions.INTERCEPT_BALL)&&(m_bestaction.player != 1))
		  ||(m_bestaction.action == Actions.CLEARING)
		  ||(m_bestaction.action == Actions.CENTER) 
		  ||(m_bestaction.action == Actions.KICK_OFF) 
		  ||(m_bestaction.action == Actions.PASS))
		{
			if ((o_bestaction.action == Actions.KICK_GOAL)
			  ||(o_bestaction.action == Actions.CATCH_BALL) 
			  ||(o_bestaction.action == Actions.CONTROL_BALL) 
			  ||(o_bestaction.action == Actions.DRIBBLE) 
			  ||((m_bestaction.action == Actions.INTERCEPT_BALL)&&(o_bestaction.player != 1))
			  ||(o_bestaction.action == Actions.CLEARING) 
			  ||(o_bestaction.action == Actions.CENTER) 
			  ||(o_bestaction.action == Actions.KICK_OFF) 
			  ||(o_bestaction.action == Actions.PASS)) return true;
		}

		return false;
	}

	public boolean MustChange(PossibleAction m_bestaction, PossibleAction o_bestaction)
	{
		/************************************************************************/
		/*******************   PRESTIGE  MODIFICATIONS   ************************/
		/************************************************************************/

		// if there is a conflict I modify the prestige depending of the action and the situation

		int rol	 = o_bestaction.player-1;
		float m_conditions = 0;
		float o_conditions = 0;

		if (m_bestaction.action == o_bestaction.action)		// if we want to do the same action
		{
			// depending of the action will be more important diferent things

			if ((m_bestaction.action == Actions.KICK_GOAL)
			  ||(m_bestaction.action == Actions.PASS))
			{
				// el ms ben encarat cap al desti del xut

				m_conditions = 1/(float)Math.abs(m_bestaction.dir);
				o_conditions = 1/(float)Math.abs(o_bestaction.dir);
			}
			else if (m_bestaction.action == Actions.INTERCEPT_BALL)
			{
				// el que tardi menys cicles a interceptar-la

				BallInfo ball = m_player.m_memory.ball;
				PlayerInfo player = m_player.m_memory.getPlayer(m_player.m_memory.m_team, o_bestaction.player);

				if (player != null)
				{
					m_conditions = 1/(float)(m_player.MyCiclesToInterceptBall(ball));
					o_conditions = 1/(float)(m_player.PlayerCiclesToInterceptBall(player, ball));
				}
				// el que tingui la pilota que es dirigeix en la seva direcci
				// el que tingui la posici d'intercepci ms a la seva zona d'influncia
			}
		}
		else	// if we do diferent actions, take the action more priority
		{
			m_conditions = m_bestaction.action;
			o_conditions = o_bestaction.action;
		}

		float m_prestige = P[m_bestaction.action][m_player.m_rol];
		float o_prestige = P[o_bestaction.action][rol];

		if (m_conditions > o_conditions)	// Zadeh modifications
		{
			m_prestige = (float)Math.sqrt(m_prestige);
			o_prestige *= o_prestige;
		}
		else if (m_conditions < o_conditions)
		{
			o_prestige = (float)Math.sqrt(o_prestige);
			m_prestige *= m_prestige;
		}

		return Ilose5(m_bestaction, m_prestige, o_bestaction, o_prestige);
	}

	public boolean Ilose1(PossibleAction m_bestaction, float m_prestige, PossibleAction o_bestaction, float o_prestige)
	{
		/************************************************************************/
		/**********************   ACTIONS EVALUATION   **************************/
		/************************************************************************/

		// eval the teammate action depending of the P and compare it with my action

		if (f.and(o_bestaction.certainty, o_prestige) > f.and(m_bestaction.certainty, m_prestige)) return true;
		else return false;
	}

	public boolean Ilose2(PossibleAction m_bestaction, float m_prestige, PossibleAction o_bestaction, float o_prestige)
	{
		/************************************************************************/
		/**********************   ACTIONS EVALUATION   **************************/
		/************************************************************************/

		/**  NECESSITY ASSIGN  **/

		BallInfo ball = m_player.m_memory.ball;
		PlayerInfo o_player = m_player.m_memory.getPlayer(m_player.m_team, o_bestaction.player);
		N = m_player.m_fuzzy.Necessity(o_bestaction.player-1, ball.m_position.X, ball.m_position.Y);

		if (N == 0) N = (float)0.01;

		// eval the teammate action depending of the N and P and compare it with my action

		float eval = 0;
		if (o_bestaction.certainty * o_prestige >= 0.1/N)
		{
			eval = f.or(f.and(o_bestaction.certainty, o_prestige), N);
		}
		else
		{
			eval = f.and(o_bestaction.certainty, o_prestige);
		}

		if (eval > m_bestaction.certainty) return true;
		else return false;
	}

	public boolean Ilose3(PossibleAction m_bestaction, float m_prestige, PossibleAction o_bestaction, float o_prestige)
	{
		/************************************************************************/
		/**********************   ACTIONS EVALUATION   **************************/
		/************************************************************************/

		/**  NECESSITY ASSIGN  **/

		BallInfo ball = m_player.m_memory.ball;
		PlayerInfo o_player = m_player.m_memory.getPlayer(m_player.m_team, o_bestaction.player);
		N = m_player.m_fuzzy.Necessity(o_bestaction.player-1, ball.m_position.X, ball.m_position.Y);

		if (N == 0) N = (float)0.01;

		// eval the teammate action depending of the N and P and compare it with my action

		float eval = 0;
		if (o_bestaction.certainty * o_prestige >= 0.1/N)
		{
			eval = f.or(f.and(o_bestaction.certainty, o_prestige), N);
		}
		else
		{
			eval = f.and(o_bestaction.certainty, o_prestige);
		}

		if (eval > f.and(m_bestaction.certainty, m_prestige)) return true;
		else return false;
	}

	public boolean Ilose4(PossibleAction m_bestaction, float m_prestige, PossibleAction o_bestaction, float o_prestige)
	{
		/************************************************************************/
		/**********************   ACTIONS EVALUATION   **************************/
		/************************************************************************/

		/**  NECESSITY ASSIGN  **/

		float condition1 = 0;
		float condition2 = 0;
		BallInfo ball = m_player.m_memory.ball;
		PlayerInfo o_player = m_player.m_memory.getPlayer(m_player.m_team, o_bestaction.player);

		condition1 = m_player.m_fuzzy.Necessity(o_bestaction.player-1, ball.m_position.X, ball.m_position.Y);
		if (o_player != null) condition2 = m_player.m_fuzzy.Necessity(o_bestaction.player-1, o_player.m_position.X, o_player.m_position.Y);
		N = f.and(condition1, condition2);

		if (N == 0) N = (float)0.01;

		// eval the teammate action depending of the N and P and compare it with my action

		float eval = 0;
		if (o_bestaction.certainty * o_prestige >= 0.1/N)
		{
			eval = f.or(f.and(o_bestaction.certainty, o_prestige), N);
		}
		else
		{
			eval = f.and(o_bestaction.certainty, o_prestige);
		}

		if (eval > m_bestaction.certainty) return true;
		else return false;
	}

	public boolean Ilose5(PossibleAction m_bestaction, float m_prestige, PossibleAction o_bestaction, float o_prestige)
	{
		/************************************************************************/
		/**********************   ACTIONS EVALUATION   **************************/
		/************************************************************************/

		/**  NECESSITY ASSIGN  **/

		float condition1 = 0;
		float condition2 = 0;
		BallInfo ball = m_player.m_memory.ball;
		PlayerInfo o_player = m_player.m_memory.getPlayer(m_player.m_team, o_bestaction.player);

		condition1 = m_player.m_fuzzy.Necessity(o_bestaction.player-1, ball.m_position.X, ball.m_position.Y);
		if (o_player != null) condition2 = m_player.m_fuzzy.Necessity(o_bestaction.player-1, o_player.m_position.X, o_player.m_position.Y);
		N = f.and(condition1, condition2);

		if (N == 0) N = (float)0.01;

		// eval the teammate action depending of the N and P and compare it with my action

		float eval = 0;
		if (o_bestaction.certainty * o_prestige >= 0.1/N)
		{
			eval = f.or(f.and(o_bestaction.certainty, o_prestige), N);
		}
		else
		{
			eval = f.and(o_bestaction.certainty, o_prestige);
		}

		if (eval > f.and(m_bestaction.certainty, m_prestige)) return true;
		else return false;
	}

	public void AssignInitialPrestige()
	{
		P = new float[Actions.N_ACTIONS][11];

		for (int i = 0; i < 11; i++)
		{
			P[Actions.CATCH_BALL][i] 	= (float) 0;
			P[Actions.KICK_OFF][i] 		= (float) 0;
			P[Actions.MOVE][i]		= (float) 1;
			P[Actions.NOP][i]		= (float) 1;
			P[Actions.SEARCH_BALL][i]	= (float) 1;
			P[Actions.ZONE][i]		= (float) 1;
		}

		P[Actions.CATCH_BALL][Rols.PORTER]	 	= (float) 1;
		P[Actions.KICK_OFF][Rols.DAVANTER_CENTRE] 	= (float) 1;

		P[Actions.KICK_GOAL][Rols.PORTER] 		= (float) 0.2;
		P[Actions.KICK_GOAL][Rols.LATERAL_DRET] 	= (float) 0.6;
		P[Actions.KICK_GOAL][Rols.CENTRAL] 		= (float) 0.5;
		P[Actions.KICK_GOAL][Rols.LATERAL_ESQUERRA]	= (float) 0.6;
		P[Actions.KICK_GOAL][Rols.PIVOT] 		= (float) 0.7;
		P[Actions.KICK_GOAL][Rols.MIG_DRET] 		= (float) 0.8;
		P[Actions.KICK_GOAL][Rols.MIG_ESQUERRA] 	= (float) 0.8;
		P[Actions.KICK_GOAL][Rols.EXTREM_DRET] 		= (float) 0.9;
		P[Actions.KICK_GOAL][Rols.DAVANTER_CENTRE]	= (float) 0.95;
		P[Actions.KICK_GOAL][Rols.MITJA_PUNTA] 		= (float) 0.85;
		P[Actions.KICK_GOAL][Rols.EXTREM_ESQUERRA]	= (float) 0.9;

		P[Actions.CENTER][Rols.PORTER] 			= (float) 0.1;
		P[Actions.CENTER][Rols.LATERAL_DRET] 		= (float) 0.2;
		P[Actions.CENTER][Rols.CENTRAL] 		= (float) 0.2;
		P[Actions.CENTER][Rols.LATERAL_ESQUERRA]	= (float) 0.2;
		P[Actions.CENTER][Rols.PIVOT] 			= (float) 0.4;
		P[Actions.CENTER][Rols.MIG_DRET] 		= (float) 0.8;
		P[Actions.CENTER][Rols.MIG_ESQUERRA] 		= (float) 0.8;
		P[Actions.CENTER][Rols.EXTREM_DRET] 		= (float) 0.9;
		P[Actions.CENTER][Rols.DAVANTER_CENTRE]		= (float) 0.6;
		P[Actions.CENTER][Rols.MITJA_PUNTA] 		= (float) 0.6;
		P[Actions.CENTER][Rols.EXTREM_ESQUERRA]		= (float) 0.9;

		P[Actions.CONTROL_BALL][Rols.PORTER] 		= (float) 0.2;
		P[Actions.CONTROL_BALL][Rols.LATERAL_DRET] 	= (float) 0.4;
		P[Actions.CONTROL_BALL][Rols.CENTRAL] 		= (float) 0.3;
		P[Actions.CONTROL_BALL][Rols.LATERAL_ESQUERRA]	= (float) 0.4;
		P[Actions.CONTROL_BALL][Rols.PIVOT] 		= (float) 0.5;
		P[Actions.CONTROL_BALL][Rols.MIG_DRET] 		= (float) 0.8;
		P[Actions.CONTROL_BALL][Rols.MIG_ESQUERRA] 	= (float) 0.8;
		P[Actions.CONTROL_BALL][Rols.EXTREM_DRET] 	= (float) 0.9;
		P[Actions.CONTROL_BALL][Rols.DAVANTER_CENTRE]	= (float) 0.7;
		P[Actions.CONTROL_BALL][Rols.MITJA_PUNTA] 	= (float) 0.7;
		P[Actions.CONTROL_BALL][Rols.EXTREM_ESQUERRA]	= (float) 0.9;

		P[Actions.DRIBBLE][Rols.PORTER] 		= (float) 0.2;
		P[Actions.DRIBBLE][Rols.LATERAL_DRET] 		= (float) 0.4;
		P[Actions.DRIBBLE][Rols.CENTRAL] 		= (float) 0.3;
		P[Actions.DRIBBLE][Rols.LATERAL_ESQUERRA]	= (float) 0.4;
		P[Actions.DRIBBLE][Rols.PIVOT] 			= (float) 0.5;
		P[Actions.DRIBBLE][Rols.MIG_DRET] 		= (float) 0.8;
		P[Actions.DRIBBLE][Rols.MIG_ESQUERRA] 		= (float) 0.8;
		P[Actions.DRIBBLE][Rols.EXTREM_DRET] 		= (float) 0.9;
		P[Actions.DRIBBLE][Rols.DAVANTER_CENTRE]	= (float) 0.7;
		P[Actions.DRIBBLE][Rols.MITJA_PUNTA] 		= (float) 0.7;
		P[Actions.DRIBBLE][Rols.EXTREM_ESQUERRA]	= (float) 0.9;

		P[Actions.CLEARING][Rols.PORTER] 		= (float) 0.9;
		P[Actions.CLEARING][Rols.LATERAL_DRET] 		= (float) 0.8;
		P[Actions.CLEARING][Rols.CENTRAL] 		= (float) 0.9;
		P[Actions.CLEARING][Rols.LATERAL_ESQUERRA]	= (float) 0.8;
		P[Actions.CLEARING][Rols.PIVOT] 		= (float) 0.7;
		P[Actions.CLEARING][Rols.MIG_DRET] 		= (float) 0.6;
		P[Actions.CLEARING][Rols.MIG_ESQUERRA] 		= (float) 0.6;
		P[Actions.CLEARING][Rols.EXTREM_DRET] 		= (float) 0.4;
		P[Actions.CLEARING][Rols.DAVANTER_CENTRE]	= (float) 0.3;
		P[Actions.CLEARING][Rols.MITJA_PUNTA] 		= (float) 0.5;
		P[Actions.CLEARING][Rols.EXTREM_ESQUERRA]	= (float) 0.4;

		P[Actions.INTERCEPT_BALL][Rols.PORTER] 		= (float) 1;
		P[Actions.INTERCEPT_BALL][Rols.LATERAL_DRET] 	= (float) 0.8;
		P[Actions.INTERCEPT_BALL][Rols.CENTRAL] 	= (float) 0.4;
		P[Actions.INTERCEPT_BALL][Rols.LATERAL_ESQUERRA]= (float) 0.8;
		P[Actions.INTERCEPT_BALL][Rols.PIVOT] 		= (float) 0.5;
		P[Actions.INTERCEPT_BALL][Rols.MIG_DRET] 	= (float) 0.8;
		P[Actions.INTERCEPT_BALL][Rols.MIG_ESQUERRA] 	= (float) 0.8;
		P[Actions.INTERCEPT_BALL][Rols.EXTREM_DRET] 	= (float) 0.8;
		P[Actions.INTERCEPT_BALL][Rols.DAVANTER_CENTRE]	= (float) 0.6;
		P[Actions.INTERCEPT_BALL][Rols.MITJA_PUNTA] 	= (float) 0.7;
		P[Actions.INTERCEPT_BALL][Rols.EXTREM_ESQUERRA]	= (float) 0.8;

		P[Actions.PASS][Rols.PORTER] 			= (float) 0.2;
		P[Actions.PASS][Rols.LATERAL_DRET] 		= (float) 0.85;
		P[Actions.PASS][Rols.CENTRAL] 			= (float) 0.9;
		P[Actions.PASS][Rols.LATERAL_ESQUERRA]		= (float) 0.85;
		P[Actions.PASS][Rols.PIVOT] 			= (float) 0.95;
		P[Actions.PASS][Rols.MIG_DRET] 			= (float) 0.8;
		P[Actions.PASS][Rols.MIG_ESQUERRA] 		= (float) 0.8;
		P[Actions.PASS][Rols.EXTREM_DRET] 		= (float) 0.7;
		P[Actions.PASS][Rols.DAVANTER_CENTRE]		= (float) 0.2;
		P[Actions.PASS][Rols.MITJA_PUNTA] 		= (float) 0.6;
		P[Actions.PASS][Rols.EXTREM_ESQUERRA]		= (float) 0.7;

	}
}