import java.lang.Math;

class Functions
{
	public Functions()
	{
	}

	public float and(float d1, float d2)
	{
		return (d1 * d2);
	}

	public float or(float d1, float d2)
	{
		return (d1 + d2 - and(d1,d2));
	}

	public float not(float d)
	{
		return (1 - d);
	}

	public int FirstXPosition(int m_rol)
	{
		if (m_rol == Rols.PORTER) 
				return -50;
		else if ((m_rol == Rols.LATERAL_DRET)
		       ||(m_rol == Rols.CENTRAL)
		       ||(m_rol == Rols.LATERAL_ESQUERRA)) 
				return -(int)(SoccerParams.FIELD_WIDTH/3);
		else if (m_rol == Rols.PIVOT)
				return -(int)(SoccerParams.FIELD_WIDTH/4);
		else if (m_rol == Rols.MITJA_PUNTA)
				return -(int)(SoccerParams.FIELD_WIDTH/8);
		else if ((m_rol == Rols.MIG_DRET) 
		       ||(m_rol == Rols.MIG_ESQUERRA)) 
				return -(int)(SoccerParams.FIELD_WIDTH/5);
		else if (m_rol == Rols.DAVANTER_CENTRE) 
				return -(int)(SoccerParams.FIELD_WIDTH/10);
		else if ((m_rol == Rols.EXTREM_DRET)
		       ||(m_rol == Rols.EXTREM_ESQUERRA)) 
				return -1;
		return -1;
	}

	public int FirstYPosition(int m_rol)
	{
		if (m_rol == Rols.EXTREM_ESQUERRA)
				return -(int)(SoccerParams.PENALTY_HEIGHT/2);
		else if (m_rol == Rols.EXTREM_DRET) 
				return (int)(SoccerParams.PENALTY_HEIGHT/2);
		else if ((m_rol == Rols.MIG_ESQUERRA) 
		       ||(m_rol == Rols.LATERAL_ESQUERRA))
				return -(int)(SoccerParams.PENALTY_HEIGHT/3);
		else if ((m_rol == Rols.LATERAL_DRET)
		       ||(m_rol == Rols.MIG_DRET)) 
				return (int)(SoccerParams.PENALTY_HEIGHT/3);
		else if ((m_rol == Rols.PORTER)
		       ||(m_rol == Rols.CENTRAL) 
		       ||(m_rol == Rols.PIVOT) 
		       ||(m_rol == Rols.MITJA_PUNTA) 
		       ||(m_rol == Rols.DAVANTER_CENTRE))
				return 0;
		return -1;
	}

	public float XZone(int rol, BallInfo ball)
	{
		float x = -1;
		char f1 = ball.m_horiz;
		char f2 = ball.m_horiz2;

		if (rol == Rols.PORTER)
		{
			if ((f1 == 'r')||(f2 == 'l')) x = -50;
		}
		else if ((rol == Rols.LATERAL_DRET)
			||(rol == Rols.CENTRAL)
			||(rol == Rols.LATERAL_ESQUERRA))
		{
			if ((f1 == 'r')&&(f2 != 'l')) x = 0;
			else if (f2 == 'l') x = -20;
			else if (f2 != 'r') x = FirstXPosition(rol);
			else x = -48;
		}
		else if (rol == Rols.PIVOT)
		{
			if ((f1 == 'r')&&(f2 != 'l')) x = 5;
			else if (f1 == 'r') x = -5;
			else if (f2 != 'r') x = FirstXPosition(rol);
			else x = -(float)(SoccerParams.FIELD_WIDTH/2 - SoccerParams.PENALTY_WIDTH);
		}
		else if ((rol == Rols.MIG_DRET)
			||(rol == Rols.MIG_ESQUERRA))
		{
			if ((f1 == 'r')&&(f2 != 'l')) x = 20;
			else if (f2 != 'l') x = FirstXPosition(rol);
		}
		else if (rol == Rols.MITJA_PUNTA)
		{
			if ((f1 == 'l')&&(f2 != 'l')) x = -20;
			else if (f2 == 'l') x = 0;
			else if ((f1 == 'r')&&(f2 == 'r')) x = (float)(SoccerParams.FIELD_WIDTH/2 - SoccerParams.PENALTY_WIDTH);
		}

		return x;
	}

	public float YZone(int rol, BallInfo ball)
	{
		float y = -1;
		char f1 = ball.m_horiz;
		char f2 = ball.m_horiz2;

		if (rol == Rols.PORTER)
		{
			if ((f1 == 'r')||(f2 == 'l')) y = 0;
		}
		else if ((rol == Rols.LATERAL_DRET)
			||(rol == Rols.CENTRAL)
			||(rol == Rols.LATERAL_ESQUERRA))
		{
			if ((f1 == 'l')&&(f2 == 'r'))
			{
				if (rol == Rols.LATERAL_DRET) 
				{
					if (ball.m_vert == 't') y = 2;
					else y = 28;
				}
				else if (rol == Rols.LATERAL_ESQUERRA) 
				{
					if (ball.m_vert == 'b') y = -2;
					else y = -28;
				}

			}
			else y = FirstYPosition(rol);
		}
		else if (rol == Rols.PIVOT)
		{
			y = 0;
		}
		else if ((rol == Rols.MIG_DRET)
			||(rol == Rols.MIG_ESQUERRA))
		{
			y = FirstYPosition(rol);
		}
		else if (rol == Rols.MITJA_PUNTA)
		{
			y = 0;
		}

		return y;
	}

	public float ControlDirection(int rol, char side, float x, float y, float dir)
	{
		Position aux = new Position(side, (float)SoccerParams.FIELD_WIDTH/2, FirstYPosition(rol), x, y, dir);

		return aux.dir;
	}

	public double getXFlag(char type, char pos1, char pos2, int num, char side)
	{
		double result=0.0;

		if (type == 'p')
		{
			switch (pos1)
			{
				case 'r': 
				{
					result=(SoccerParams.FIELD_WIDTH/2-SoccerParams.PENALTY_WIDTH);
					break;
				}
				case 'l': 
				{
					result=-(SoccerParams.FIELD_WIDTH/2-SoccerParams.PENALTY_WIDTH);
					break;
				}
			}
		}
		else	// 'g'|' '
		{
			switch (pos1)
			{
				case 'r': 
				{
					if (pos2 == ' ') result=(SoccerParams.FIELD_WIDTH/2+5);	// flag r 0
					else
					{
						if (num == 0) result=(SoccerParams.FIELD_WIDTH/2);	// flag <g> r {t|b}
						else result=(SoccerParams.FIELD_WIDTH/2+5);		// flag r {t|b} num
					}
					break;
				}
				case 'l': 
				{
					if (pos2 == ' ') result=-(SoccerParams.FIELD_WIDTH/2+5);	// flag l 0
					else
					{
						if (num == 0) result=-(SoccerParams.FIELD_WIDTH/2);	// flag <g> l {t|b}
						else result=-(SoccerParams.FIELD_WIDTH/2+5);		// flag l {t|b} num
					}
					break;
				}
				case 'c': 
				{
					result=0;
					break;
				}
				case 't': 
				{
					if (pos2 == 'l') result=-num;
					else result=num;
					break;
				}
				case 'b': 
				{
					if (pos2 == 'l') result=-num;
					else result=num;
					break;
				}
			}
		}

		if (side == 'r') return -result;
		else return result;
	}

	public double getYFlag(char type, char pos1, char pos2, int num, char side)
	{
		double result=0.0;

		if (type == 'p')
		{
			switch (pos2)
			{
				case 'b': 
				{
					result=(SoccerParams.PENALTY_HEIGHT/2);
					break;
				}
				case 't': 
				{
					result=-(SoccerParams.PENALTY_HEIGHT/2);
					break;
				}
				case 'c': 
				{
					result=0.0;
					break;
				}
			}
		}
		else if (type == 'g')
		{
			switch (pos2)
			{
				case 'b': 
				{
					result=(SoccerParams.GOAL_WIDTH/2);
					break;
				}
				case 't': 
				{
					result=-(SoccerParams.GOAL_WIDTH/2);
					break;
				}
				case 'c': 
				{
					result=0;
					break;
				}
			}
		}
		else
		{
			switch (pos2)
			{
				case ' ':					// flag c | flag {l|r} 0
				{
					if (pos1 == 't') result=-(SoccerParams.FIELD_HEIGHT/2+5);
					else if (pos1 == 'b') result=(SoccerParams.FIELD_HEIGHT/2+5);
					else result=0.0;
					break;
				}
				case 'b': 
				{
					if (num == 0) result=(SoccerParams.FIELD_HEIGHT/2);
					else result=num;
					break;
				}
				case 't': 
				{
					if (num == 0) result=-(SoccerParams.FIELD_HEIGHT/2);
					else result=-num;
					break;
				}
				case 'l': 
				{
					if (pos1 == 'b') result=(SoccerParams.FIELD_HEIGHT/2+5);
					else result=-(SoccerParams.FIELD_HEIGHT/2+5);
					break;
				}
				case 'r': 
				{
					if (pos1 == 'b') result=(SoccerParams.FIELD_HEIGHT/2+5);
					else result=-(SoccerParams.FIELD_HEIGHT/2+5);
					break;
				}
			}
		}

		if (side == 'r') return -result;
		else return result;
	}

	public int PassPriority(int number, int priority)
	{
		switch (number)
		{
			case 1:
			{
				switch (priority)
				{
					case 1 : return 2;
					case 2 : return 4;
					case 3 : return 6;
					case 4 : return 7;
					case 5 : return 8;
					case 6 : return 11;
				}
			}
			case 2:
			{
				switch (priority)
				{
					case 1 : return 8;
					case 2 : return 6;
					case 3 : return 9;
					case 4 : return 10;
					case 5 : return 5;
					case 6 : return 7;
				}
			}
			case 3:
			{
				switch (priority)
				{
					case 1 : return 8;
					case 2 : return 11;
					case 3 : return 6;
					case 4 : return 7;
					case 5 : return 10;
					case 6 : return 5;
				}
			}
			case 4:
			{
				switch (priority)
				{
					case 1 : return 11;
					case 2 : return 7;
					case 3 : return 9;
					case 4 : return 10;
					case 5 : return 5;
					case 6 : return 6;
				}
			}
			case 5:
			{
				switch (priority)
				{
					case 1 : return 8;
					case 2 : return 11;
					case 3 : return 9;
					case 4 : return 6;
					case 5 : return 7;
					case 6 : return 10;
				}
			}
			case 6:
			{
				switch (priority)
				{
					case 1 : return 8;
					case 2 : return 9;
					case 3 : return 10;
					case 4 : return 11;
					case 5 : return 7;
					case 6 : return 7;
				}
			}
			case 7:
			{
				switch (priority)
				{
					case 1 : return 11;
					case 2 : return 9;
					case 3 : return 10;
					case 4 : return 8;
					case 5 : return 6;
					case 6 : return 6;
				}
			}
			case 8:
			{
				switch (priority)
				{
					case 1 : return 9;
					case 2 : return 11;
					case 3 : return 10;
					case 4 : return 10;
					case 5 : return 10;
					case 6 : return 10;
				}
			}
			case 9:
			{
				switch (priority)
				{
					case 1 : return 8;
					case 2 : return 11;
					case 3 : return 11;
					case 4 : return 11;
					case 5 : return 11;
					case 6 : return 11;
				}
			}
			case 10:
			{
				switch (priority)
				{
					case 1 : return 9;
					case 2 : return 8;
					case 3 : return 11;
					case 4 : return 11;
					case 5 : return 11;
					case 6 : return 11;
				}
			}
			case 11:
			{
				switch (priority)
				{
					case 1 : return 9;
					case 2 : return 8;
					case 3 : return 10;
					case 4 : return 10;
					case 5 : return 10;
					case 6 : return 10;
				}
			}
		}

		return 0;
	}

	public float radiants(float angle)
	{
		return (float)((angle*Math.PI)/180);
	}

	public float degrees(float angle)
	{
		return (float)((angle*180)/Math.PI);
	}

	public float StandarizeAngle(float angle)
	{
		while ((angle > 360)||(angle < -360))
		{
			if (angle>360) angle = angle-360;
			else if (angle<-360) angle = angle+360;
		}

		if (angle>180) angle = angle-360;
		else if (angle<-180) angle = angle+360;

		return angle;
	}
}

