import java.util.*;

class HearInfo
{
	public int	receiver;
	public int 	send_time;
	public int 	sender;
	public float 	X;
	public float 	Y;
	public float 	Dir;
	public float 	velX;
	public float 	velY;
	public int 	prediction;
	public int 	decision;
	public float 	certainty;
	public float 	end_dir;
	public int 	rol;
	public float 	stamina;
	public float 	effort;
	public float	recover;
	public String	message;

	public HearInfo(String info)
	{
		message = info;
		info.trim();
		StringTokenizer m_tokenizer = new StringTokenizer(info,"() ", true);
		String token = null;

		try
		{
			token = m_tokenizer.nextToken();				// '('
			receiver = Integer.parseInt( m_tokenizer.nextToken() ); 	// 'receiver'
			token = m_tokenizer.nextToken();				// ' '
			send_time = Integer.parseInt( m_tokenizer.nextToken() ); 	// send_time
			token = m_tokenizer.nextToken();				// ' '
			token = m_tokenizer.nextToken();				// '('
			sender = Integer.parseInt( m_tokenizer.nextToken() ); 		// sender
			token = m_tokenizer.nextToken();				// ' '
			X = Float.valueOf(m_tokenizer.nextToken()).floatValue();	// X
			token = m_tokenizer.nextToken();				// ' '
			Y = Float.valueOf(m_tokenizer.nextToken()).floatValue();	// Y
			token = m_tokenizer.nextToken();				// ' '
			Dir = Float.valueOf(m_tokenizer.nextToken()).floatValue();	// Dir
			token = m_tokenizer.nextToken();				// ' '
			velX = Float.valueOf(m_tokenizer.nextToken()).floatValue();	// velX
			token = m_tokenizer.nextToken();				// ' '
			velY = Float.valueOf(m_tokenizer.nextToken()).floatValue();	// velY
			token = m_tokenizer.nextToken();				// ' '
			prediction = Integer.parseInt( m_tokenizer.nextToken() ); 	// prediction
			token = m_tokenizer.nextToken();				// ' '
			decision = Integer.parseInt( m_tokenizer.nextToken() ); 	// decision
			token = m_tokenizer.nextToken();				// ' '
			certainty = Float.valueOf(m_tokenizer.nextToken()).floatValue();// certainty
			token = m_tokenizer.nextToken();				// ' '
			end_dir = Float.valueOf(m_tokenizer.nextToken()).floatValue();	// end_dir
			token = m_tokenizer.nextToken();				// ' '
			rol = Integer.parseInt( m_tokenizer.nextToken() ); 		// rol
			token = m_tokenizer.nextToken();				// ' '
			stamina=Float.valueOf(m_tokenizer.nextToken()).floatValue();	// stamina
			token = m_tokenizer.nextToken();				// ' '
			effort=Float.valueOf(m_tokenizer.nextToken()).floatValue();	// effort
			token = m_tokenizer.nextToken();				// ' '
			recover=Float.valueOf(m_tokenizer.nextToken()).floatValue();	// recover
			token = m_tokenizer.nextToken();				// ')'
			token = m_tokenizer.nextToken();				// ')'
		}
		catch(Exception e)
		{
			System.out.println("Error parsing hear information");
			System.out.println(token);
			while( m_tokenizer.hasMoreTokens() ) System.out.print(m_tokenizer.nextToken());

			System.out.println("");
		}
	}

	public HearInfo(int receiver2, int send_time2, int sender2, float X2, float Y2, float Dir2, float velX2, 
			float velY2, int prediction2, int decision2, float certainty2, float end_dir2, int rol2, 
			float stamina2, float effort2, float recover2)
	{
		receiver = receiver2;
		send_time = send_time2;
		sender = sender2;
		X = X2;
		Y = Y2;
		Dir = Dir2;
		velX = velX2;
		velY = velY2;
		prediction = prediction2;
		decision = decision2;
		certainty = certainty2;
		end_dir = end_dir2;
		rol = rol2;
		stamina = stamina2;
		effort = effort2;
		recover = recover2;
		message = "("+receiver+" "+send_time+" ("+sender+" "+X+" "+Y+" "+Dir+" "+velX+" "+velY+" "+prediction;
		message = message+" "+decision+" "+certainty+" "+end_dir+" "+rol+" "+stamina+" "+effort+" "+recover+"))";
	}
}
