import java.io.*;
import java.net.*;
import java.util.StringTokenizer;

class HearSoccerServer extends Thread
{
	public rogi2		m_rogi2;
	public DatagramSocket	m_socket;		

	public HearSoccerServer(rogi2 r2, DatagramSocket socket)
	{
		m_rogi2 = r2;
		m_socket = socket;

		start();
	}
																 
	public void run()
	{
		try
		{
			while (true) parseSensorInformation(receive());
		}
		catch (Exception e)
		{
			System.out.println(e.getMessage());
			System.out.println("Error al rebre dades del SoccerServer !");
		}
	}

	public void parseSensorInformation(String message)
	{
		if( message.charAt(1) == 's' )
		{
			if( message.charAt(3) == 'e' )				// see information
			{
				SeeInfo info = new SeeInfo(message);
			
				m_rogi2.m_info=info;
			}
			else							// sense_body information
			{
				SenseBodyInfo info2 = new SenseBodyInfo(message);

				m_rogi2.m_brain.sense_body(info2);
			}
		}
		else if( message.charAt(1) == 'h' ) parseHear(message);		// hear information
	}

	public void parseHear(String message)
	{
		StringTokenizer	tokenizer = new StringTokenizer(message,"() ");
		int	time;
		String sender;

		tokenizer.nextToken();
		time = Integer.parseInt( tokenizer.nextToken() );
		sender = tokenizer.nextToken();
		if( sender.compareTo("referee") == 0 ) m_rogi2.m_brain.hear(time, tokenizer.nextToken());
		else if( sender.compareTo("self") != 0 ) 
		{
			HearInfo info = new HearInfo(message);
			m_rogi2.m_brain.hear(info);
		}
	}

	public String receive() 
	{
		byte[] buffer = new byte[SoccerParams.SOCCERSERVER_MSG_SIZE];
		DatagramPacket packet = new DatagramPacket(buffer, SoccerParams.SOCCERSERVER_MSG_SIZE);

		try
		{
			m_socket.receive(packet);
		}
		catch(IOException e)
		{
			System.err.println("socket receiving error " + e);
		}
		return new String(buffer);
	}
}
