import java.util.*;

class ListPossibleActions
{
	public Vector m_actions;
	private Functions f = new Functions();

	public ListPossibleActions()
	{
		m_actions = new Vector(50);
	}

	public ListPossibleActions(ListPossibleActions l)
	{
		m_actions = new Vector(50);
		int size = l.m_actions.size();
		for(int c = 0 ; c < size ; c ++)
		{
			m_actions.addElement((PossibleAction)l.m_actions.elementAt(c));
		}
	}

	public void addAction(int action, int player, float certainty, float rule_c, int time, float dir)
	{
		PossibleAction a = new PossibleAction(action, player, f.and(certainty, rule_c), time, dir);
		m_actions.addElement(a);
	}

	public PossibleAction MoreCertainty(int player)
	{
		PossibleAction result = null;
		float certainty = -1;

		int size = m_actions.size();
		for(int c = 0 ; c < size ; c ++)
		{
			PossibleAction action = (PossibleAction)m_actions.elementAt(c);
			if ((action.player == player)&&(action.certainty > certainty))
			{
				certainty = action.certainty;
				result = action;
			}
		}

		return result;
	}

	public void removeAction(int player)
	{
		int size = m_actions.size();
		for(int c = size-1 ; c >= 0 ; c --)
		{
			PossibleAction act = (PossibleAction)m_actions.elementAt(c);
			if (act.player == player) m_actions.removeElementAt(c);
		}		
	}

	public void removeOldActions(int time)
	{
		int OLD = 3;

		int size = m_actions.size();
		for(int c = size-1 ; c >= 0 ; c --)
		{
			PossibleAction act = (PossibleAction)m_actions.elementAt(c);
			if (act.time < time-OLD) m_actions.removeElementAt(c);
		}		
	}

	public void removeAction(int action, int player)
	{
		boolean removed = false;
		int c = m_actions.size()-1;

		while ((c >= 0)&&(!removed))
		{
			PossibleAction act = (PossibleAction)m_actions.elementAt(c);
			if ((act.action == action)&&(act.player == player))
			{
				m_actions.removeElementAt(c);
				removed = true;
			}

			c--;
		}		
	}

	public void removeActions()
	{
		for(int c = m_actions.size()-1 ; c >= 0  ; c--)
		{
			m_actions.removeElementAt(c);
		}
	}

	public void print()
	{
		System.out.println(m_actions.size()+"  POSSIBLE ACTIONS");
		for (int i=0; i < m_actions.size(); i++)
		{
			PossibleAction action = (PossibleAction)m_actions.elementAt(i);
			action.print();
		}
		System.out.println(" ");
	}
}