import java.util.Vector;

class Memory 
{
	public int		m_time = -1;
	public char		m_side;
	public int		m_number;
	public String		m_team;
	public float 		myX = 0;
	public float 		myY = 0;
	public float 		m_velX = 0;
	public float 		m_velY = 0;
	public float 		myDir = 0;
	public float 		m_stamina = SoccerParams.STAMINA_MAX;
	public float 		m_effort = 1;
	public float 		m_recover = 1;
	public float 		m_speed = 0;
	public float 		m_head_angle = 0;
	public int 		m_prediction = 0;
	public BallInfo		ball = null;
	public GoalInfo 	goal_l = null;
	public GoalInfo 	goal_r = null;
	public Vector		m_players = new Vector(10);
	public Vector		o_players = new Vector(21);
	public boolean		m_outside = false;
	public boolean		wait = false;
	private boolean 	FirstSeeInformation = true;
	private Functions 	f = new Functions();
	ListPossibleActions 	o_actions = new ListPossibleActions();

	public Memory(String team, int number, char side)
	{
		m_team = team;
		m_number=number;
		m_side=side;
	}

	public void see(SeeInfo info, int time)
	{
		m_time = time;
		o_actions.removeOldActions(m_time);		// ignore old the reactive actions of the other players

		if (info==null) info = new SeeInfo();		// I haven't seen anything in this cycle
		else wait=false;				// end of wait

		SeeInfo new_info = new SeeInfo();

		// ########################################################
		// #######  calculate my position and my direction  #######
		// ########################################################

		LineInfo line = FarLine(info);

		if (line != null) 
		{
			// I see a line , I can calculate my actual direction 

			myDir = f.StandarizeAngle(line.getMyDir());
		}

		FlagInfo flag = NearFlag(info);

		if (flag != null)
		{
			// I see a flag , I can calculate my actual position 

			double flagx = f.getXFlag(flag.m_type2, flag.m_pos1, flag.m_pos2, flag.m_num, m_side);
			double flagy = f.getYFlag(flag.m_type2, flag.m_pos1, flag.m_pos2, flag.m_num, m_side);

			if (m_side == 'l')
			{
				myX=(float)(flagx-Math.cos(f.radiants(flag.m_direction+myDir))*flag.m_distance);
				myY=(float)(flagy-Math.sin(f.radiants(flag.m_direction+myDir))*flag.m_distance);
			}
			else
			{
				myX=(float)(flagx+Math.cos(f.radiants(flag.m_direction+myDir))*flag.m_distance);
				myY=(float)(flagy+Math.sin(f.radiants(flag.m_direction+myDir))*flag.m_distance);
			}

			m_prediction=0;
		}
		else
		{
			// I can't see a flag , I make a prediction of my position

			if (FirstSeeInformation == true)
			{
				// if I don't have my old information (only in the begining), I take my fist position

				myX=(float)f.FirstXPosition(m_number-1);
				myY=(float)f.FirstYPosition(m_number-1);

				FirstSeeInformation = false;
			}
			else
			{
				myX += m_velX;
				myY += m_velY;
			}

			m_prediction++;
		}

		// ########################################################
		// ###########  update sense_body params  #################
		// ########################################################

		if (m_stamina <= SoccerParams.RECOVER_DEC_THR*SoccerParams.STAMINA_MAX)
		{
			m_recover = (float)(Math.max(SoccerParams.RECOVER_MIN, m_recover-SoccerParams.RECOVER_DEC));
		}

		if (m_stamina <= SoccerParams.EFFORT_DEC_THR*SoccerParams.STAMINA_MAX)
		{
			m_effort = (float)(Math.max(SoccerParams.EFFORT_MIN, m_effort-SoccerParams.EFFORT_DEC));
		}
		else if (m_stamina >= SoccerParams.EFFORT_INC_THR*SoccerParams.STAMINA_MAX)
		{
			m_effort = (float)(Math.min(1.0, m_effort+SoccerParams.EFFORT_INC));
		}

		m_stamina = (float)(Math.min(SoccerParams.STAMINA_MAX, m_stamina+(m_recover*SoccerParams.STAMINA_INC_MAX)));

		m_speed = (float)(Math.sqrt(m_velX*m_velX + m_velY*m_velY));

		m_velX *= SoccerParams.PLAYER_DECAY;
		m_velY *= SoccerParams.PLAYER_DECAY;

		// ###############################################################
		// ######################  add ball  #############################
		// ###############################################################

		BallInfo b = (BallInfo)info.getObject("ball");

		if (b != null)	// I can see the ball
		{
			Position aux = new Position(b.m_direction, b.m_distance, m_side, myX,myY,myDir);
			ball.m_position=aux;
			ball.m_distance = aux.dist;
			ball.m_direction = aux.dir;
			ball.m_distChange = b.m_distChange;
			ball.m_dirChange = b.m_dirChange;
			ball.m_prediction = 0;
			ball.lost = false;

			if (ball.m_distChange != -1)
			{
				float vrx = ball.m_distChange*(float)Math.cos(f.radiants(ball.m_direction)) + ((float)Math.PI/180)*ball.m_dirChange*ball.m_distance*(float)Math.sin(f.radiants(ball.m_direction));
				float vry = ball.m_distChange*(float)Math.sin(f.radiants(ball.m_direction)) + ((float)Math.PI/180)*ball.m_dirChange*ball.m_distance*(float)Math.cos(f.radiants(ball.m_direction));

				vrx *= (float)SoccerParams.BALL_DECAY;
				vry *= (float)SoccerParams.BALL_DECAY;

				float vr = (float)Math.sqrt(vrx*vrx +vry*vry);
				float a = 0;
				if (vrx != 0) a = f.degrees((float)Math.atan(vry / vrx));

				float vx = vr*(float)Math.cos(f.radiants(a+myDir));
				float vy = vr*(float)Math.sin(f.radiants(a+myDir));

				ball.m_velX = m_velX - vx;
				ball.m_velY = m_velY - vy;
			}
			else
			{
				ball.m_velX *= SoccerParams.BALL_DECAY;
				ball.m_velY *= SoccerParams.BALL_DECAY;
			}
		}
		else	// I can't see the ball
		{
			Position aux = null;
			if (ball != null)
			{
				// I make a PREDICTION

				aux = new Position(m_side, ball.m_position.X+ball.m_velX, ball.m_position.Y+ball.m_velY, myX, myY, myDir);

				ball.m_velX *= SoccerParams.BALL_DECAY;
				ball.m_velY *= SoccerParams.BALL_DECAY;
			}
			else
			{
				// I take the initial position

				ball = new BallInfo();
				aux = new Position(m_side, 0, 0, myX,myY,myDir);
			}

			ball.m_position=aux;
			ball.m_direction = aux.dir;
			ball.m_distance = aux.dist;

			int size = info.m_objects.size();
			if ((size != 0)&&(Math.abs(ball.m_direction) < SoccerParams.VISIBLE_ANGLE/2)) 
			{
				ball.m_prediction = 100;
				ball.lost = true;
			}
			else ball.m_prediction++;
		}

		ball.CalculateFlags();

		// ###############################################################
		// #####################  add opponents  #########################
		// ###############################################################

		int size = info.m_objects.size();
		if (size != 0) o_players = new Vector(21);

		for(int c = 0 ; c < size ; c ++)
		{
			ObjectInfo obj = (ObjectInfo)info.m_objects.elementAt(c);

			if (obj.m_type.compareTo("player") == 0)
			{
				PlayerInfo player = (PlayerInfo)obj;

				if (player.m_team != m_team)
				{
					Position aux = new Position(player.m_direction, player.m_distance, m_side, myX,myY,myDir);
					player.m_position=aux;
					player.m_prediction=0;
					player.CalculateFlags();

					if (player.m_distChange != -1)
					{
						float vrx = player.m_distChange*(float)Math.cos(f.radiants(player.m_direction)) + ((float)Math.PI/180)*player.m_dirChange*player.m_distance*(float)Math.sin(f.radiants(player.m_direction));
						float vry = player.m_distChange*(float)Math.sin(f.radiants(player.m_direction)) + ((float)Math.PI/180)*player.m_dirChange*player.m_distance*(float)Math.cos(f.radiants(player.m_direction));

						vrx *= (float)SoccerParams.PLAYER_DECAY;
						vry *= (float)SoccerParams.PLAYER_DECAY;

						float vr = (float)Math.sqrt(vrx*vrx +vry*vry);
						float a = 0;
						if (vrx != 0) a = f.degrees((float)Math.atan(vry / vrx));

						float vx = vr*(float)Math.cos(f.radiants(a+myDir));
						float vy = vr*(float)Math.sin(f.radiants(a+myDir));

						player.m_velX = m_velX - vx;
						player.m_velY = m_velY - vy;
					}
					else
					{
						player.m_velX = 0;
						player.m_velY = 0;
					}
				
					player.m_stamina = SoccerParams.STAMINA_MAX;
					player.m_effort = 1;
					player.m_recover = 1;

					addPlayer(player);
				}
			}
		}
	}

	public void sense_body(SenseBodyInfo info)
	{
		m_stamina = info.stamina;
		m_effort = info.effort;
/*
		m_speed = info.speed;
		m_velX = m_speed*(float)Math.cos(f.radiants(myDir));
		m_velY = m_speed*(float)Math.sin(f.radiants(myDir));
*/
		m_head_angle = info.head_angle;
	}

	public void hear(HearInfo info)
	{
		o_actions.removeAction(info.sender);
		o_actions.addAction(info.decision, info.sender, info.certainty, 1, info.send_time, info.end_dir);

		// ###############################################################
		// #####################  add teammates  #########################
		// ###############################################################

		PlayerInfo player = new PlayerInfo(m_team, info.sender);
		Position aux2 = new Position(m_side, info.X, info.Y, myX,myY,myDir);
		player.m_position=aux2;
		player.m_direction = aux2.dir;
		player.m_distance = aux2.dist;
		player.m_distChange = 0;
		player.m_dirChange = 0;
		player.FaceDir = info.Dir-myDir;
		player.m_velX = info.velX;
		player.m_velY = info.velY;
		player.m_stamina = info.stamina;
		player.m_effort = info.effort;
		player.m_recover = info.recover;
		player.m_prediction = info.prediction;

		addPlayer(player);
	}

	public FlagInfo Flag(char type, char pos1, char pos2, int num, float myX, float myY, float myDir, char m_side)
	{
		boolean out=false;

		if (num!=0) out=true;
		if (((pos1=='l')||(pos1=='r')||(pos1=='t')||(pos1=='b')) && (pos2==' ')) out=true;

		FlagInfo o = new FlagInfo(type, pos1, pos2, num, out);

		float x = (float)f.getXFlag(type, pos1, pos2, num, m_side);
		float y = (float)f.getYFlag(type, pos1, pos2, num, m_side);

		Position aux = new Position(m_side, x,y,myX,myY,myDir);

		o.m_distance=aux.dist;
		o.m_direction=aux.dir;
		o.m_distChange=0;
		o.m_dirChange=0;
		o.m_position=aux;

		return o;
	}

	public void TurnmyDir(float dir)
	{
//		float moment = (float)(dir / (1.0 + SoccerParams.INERTIA_MOMENT*m_speed));
//		myDir = f.StandarizeAngle(myDir+moment);

		myDir = f.StandarizeAngle(myDir+dir);
	}

	public void SetmyVel(int power)
	{
		float effective_power;
		if (power < 0) 
		{
			if (-2*power > m_stamina) effective_power = m_stamina;
			else effective_power = -power;
		}
		else effective_power = (float)Math.min(power, m_stamina);

		effective_power *= m_effort;

		float accX = (float)(Math.cos(f.radiants(myDir))*effective_power*SoccerParams.DASH_POWER_RATE);
		float accY = (float)(Math.sin(f.radiants(myDir))*effective_power*SoccerParams.DASH_POWER_RATE);

		m_velX += accX;
		m_velY += accY;

		if (power<0) power *= -2;
		m_stamina = (float)(Math.max(m_stamina-power, 0));
	}

	public void SetBallVel(int power, float dir)
	{
		float accX = (float)(Math.cos(f.radiants(myDir+dir))*power*ball.KickRate());
		float accY = (float)(Math.sin(f.radiants(myDir+dir))*power*ball.KickRate());

		ball.m_velX += accX;	
		ball.m_velY += accY;
	}

	public FlagInfo NearFlag(SeeInfo info)
	{
		FlagInfo flag = null;
		float dist = 999;

		int size = info.m_objects.size();
		for(int c = 0 ; c < size ; c ++)
		{
			ObjectInfo obj = (ObjectInfo)info.m_objects.elementAt(c);

			if (obj.m_type.compareTo("flag") == 0)
			{
				FlagInfo f = (FlagInfo)obj;
				if ((f.m_type2 != ' ')||(f.m_pos1 != ' ')||(f.m_pos2 != ' '))
				{
					if (f.m_distance < dist)
					{
						flag = f;
						dist = f.m_distance;
					}
				}
			}
		}

		return flag;
	}

	public FlagInfo NearFlagWithCh(SeeInfo info)
	{
		FlagInfo flag = null;
		float dist = 999;

		int size = info.m_objects.size();
		for(int c = 0 ; c < size ; c ++)
		{
			ObjectInfo obj = (ObjectInfo)info.m_objects.elementAt(c);

			if (obj.m_type.compareTo("flag") == 0)
			{
				FlagInfo f = (FlagInfo)obj;
				if ((f.m_type2 != ' ')||(f.m_pos1 != ' ')||(f.m_pos2 != ' '))
				{
					if ((f.m_distChange != -1)&&(f.m_distance < dist))
					{
						flag = f;
						dist = f.m_distance;
					}
				}
			}
		}

		return flag;
	}

	public LineInfo FarLine(SeeInfo info)
	{
		LineInfo line = null;
		float dist = 0;

		int size = info.m_objects.size();
		for(int c = 0 ; c < size ; c ++)
		{
			ObjectInfo obj = (ObjectInfo)info.m_objects.elementAt(c);
			if (obj.m_type.compareTo("line") == 0)
			{
				if (obj.m_distance > dist) 
				{
					line = (LineInfo)obj;
					dist = line.m_distance;
				}
			}
		}

		return line;
	}

	public PlayerInfo getPlayer(String team, int number) 
	{
		if (team == m_team)
		{
			for(int c = 0 ; c < m_players.size() ; c ++)
			{
				PlayerInfo player = (PlayerInfo)m_players.elementAt(c);
				if (player.m_number == number) return player;
			}
		}
		else
		{
			for(int c = 0 ; c < o_players.size() ; c ++)
			{
				PlayerInfo player = (PlayerInfo)o_players.elementAt(c);
				if (player.m_number == number) return player;
			}
		}

		return null;
	}

	public int getIndexPlayer(String team, int number) 
	{
		if (team == m_team)
		{
			for(int c = 0 ; c < m_players.size() ; c ++)
			{
				PlayerInfo player = (PlayerInfo)m_players.elementAt(c);
				if (player.m_number == number) return c;
			}
		}
		else
		{
			for(int c = 0 ; c < o_players.size() ; c ++)
			{
				PlayerInfo player = (PlayerInfo)o_players.elementAt(c);
				if (player.m_number == number) return c;
			}
		}

		return -1;											 
	}

	public void addPlayer(PlayerInfo player)
	{
		PlayerInfo p = getPlayer(player.m_team, player.m_number);

		if (player.m_team == m_team)
		{
			if (p == null) m_players.addElement(player);
			else m_players.setElementAt(player, getIndexPlayer(player.m_team, player.m_number));
		}
		else
		{
			if (p == null) o_players.addElement(player);
			else o_players.setElementAt(player, getIndexPlayer(player.m_team, player.m_number));
		}
	}
}

