import java.lang.Math;

class MobileObject extends ObjectInfo
{
	public char	m_horiz;			// l|r
	public char	m_vert;				// t|b
	public char	m_horiz2;			// l|c|r
	public char	m_vert2;			// t|b

	public float 	m_velX;
	public float 	m_velY;
	public int 	m_prediction;

	public MobileObject(String type)
	{
		super(type);
		m_prediction=0;
		m_velX=0;
		m_velY=0;
		m_horiz=' ';
		m_vert=' ';
		m_horiz2=' ';
		m_vert2=' ';
	}

	public MobileObject(MobileObject o)
	{
		super((ObjectInfo)o);
		m_prediction=o.m_prediction;
		m_velX=o.m_velX;
		m_velY=o.m_velY;
		m_horiz=o.m_horiz;
		m_vert=o.m_vert;
		m_horiz2=o.m_horiz2;
		m_vert2=o.m_vert2;
	}

	public void CalculateFlags()
	{
		float x = m_position.X;
		float y = m_position.Y;

		if (x < 0) m_horiz='l';
		else m_horiz='r';

		if (y < 0) m_vert='t';
		else m_vert='b';

		if (Math.abs(x) > (SoccerParams.FIELD_WIDTH/2-SoccerParams.PENALTY_WIDTH)) m_horiz2='r';
		else if (Math.abs(x) < SoccerParams.PENALTY_WIDTH) m_horiz2='l';
		else m_horiz2='c';

		if (Math.abs(y) < (SoccerParams.PENALTY_HEIGHT/2)) m_vert2='b';
		else m_vert2='t';
	}

	public void print()
	{
		super.print();
		System.out.println("PREDICCIO="+m_prediction+" VELX="+m_velX+" VELY="+m_velY);
//		System.out.println("FLAGS="+m_horiz+" "+m_vert+" "+m_horiz2+" "+m_vert2);
	}
}

