class One extends Player
{
	// **** RULES_CERTAINTY ****

	public static float 	NOP_CERTAINTY		= (float) 0.4;
	public static float 	MOVE_CERTAINTY		= (float) 1;
	public static float 	SEARCH_BALL_CERTAINTY	= (float) 1;

	public static float 	ZONE_CERTAINTY		= (float) 0.6;
	public static float 	INTERCEPT_BALL_CERTAINTY= (float) 1;

	public static float 	CLEARING_CERTAINTY	= (float) 0.5;
	public static float 	PASS_CERTAINTY		= (float) 0.8;
	public static float 	CATCH_BALL_CERTAINTY	= (float) 1;

	private boolean catchball = false;
	private int catchcicles = 0;
	private int freekickcicles = 0;

	public One(rogi2 r2, Memory memory, char side, String playMode, String team, int number)
	{
		super(r2, memory, side, playMode, team, number);
	}

	public void TakeReactiveDecision(Memory memory, String playMode)
	{
		m_memory = memory;
		m_playMode = playMode;

		char o_side = 'l';
		if (m_side == 'l') o_side = 'r';
		BallInfo ball = m_memory.ball;
		m_actions = new ListPossibleActions();

		if ((m_playMode.compareTo("before_kick_off") == 0)
		  ||(m_playMode.compareTo("goal_l") == 0)
		  ||(m_playMode.compareTo("goal_r") == 0)) 
		{
			m_actions.addAction(Actions.MOVE, m_number,
				1,
				MOVE_CERTAINTY,
				m_memory.m_time, 0);
		}
		else if ((m_playMode.compareTo("kick_off_"+m_side) == 0)
		       ||(m_playMode.compareTo("kick_off_"+o_side) == 0))
		{
			m_actions.addAction(Actions.NOP, m_number,
				1,
				NOP_CERTAINTY,
				m_memory.m_time, 0);
		}
		else if ((m_playMode.compareTo("free_kick_"+m_side) == 0)
		       ||(m_playMode.compareTo("goal_kick_"+m_side) == 0))
		{
			if ((!catchball)&&(m_memory.m_time-lastcatch < 5)) catchball = true;

			if (catchball)
			{
				ball.m_position.X = m_memory.myX;
				ball.m_position.Y = m_memory.myY;
				m_memory.ball = ball;

				if (catchcicles < 30)
				{
					m_actions.addAction(Actions.NOP, m_number,
						1,
						NOP_CERTAINTY,
						m_memory.m_time, 0);

					catchcicles++;
				}
				else 
				{
					if (catchcicles < 60)
					{
						float cankick = m_fuzzy.CanKick(ball);
						float canpass = m_fuzzy.CanPass(ball);

						m_actions.addAction(Actions.PASS, m_number,
							f.and( cankick, 
							       canpass), 
							PASS_CERTAINTY,
							m_memory.m_time, m_fuzzy.PassDir);

						m_actions.addAction(Actions.MOVE, m_number,
							(float)0.4,
							MOVE_CERTAINTY,
							m_memory.m_time, 0);

						catchcicles++;
					}
					else
					{
						float cankick = m_fuzzy.CanKick(ball);

						m_actions.addAction(Actions.CLEARING, m_number,
							cankick, 
							CLEARING_CERTAINTY,
							m_memory.m_time, 0);
					}
				}
			}
			else
			{
				float cankick = m_fuzzy.CanKick(ball);

				if (cankick>0.9)
				{
					if (freekickcicles < 20)
					{
						m_actions.addAction(Actions.NOP, m_number,
							1,
							NOP_CERTAINTY,
							m_memory.m_time, 0);

						freekickcicles++;
					}
					else
					{
						float canpass 		= m_fuzzy.CanPass(ball);

						m_actions.addAction(Actions.CLEARING, m_number,
							cankick, 
							CLEARING_CERTAINTY,
							m_memory.m_time, 0);

						m_actions.addAction(Actions.PASS, m_number,
							f.and( cankick, 
							       canpass), 
							PASS_CERTAINTY,
							m_memory.m_time, m_fuzzy.PassDir);
					}
				}
				else
				{
					float goodprediction 	= m_fuzzy.GoodPrediction(ball);
					float zone		= m_fuzzy.Zone(m_rol, m_memory.myX, m_memory.myY, ball);
					float freekickzone	= m_fuzzy.FreeKickZone(m_rol, ball.m_position.X, ball.m_position.Y);

					m_actions.addAction(Actions.NOP, m_number,
						1,
						NOP_CERTAINTY,
						m_memory.m_time, 0);

					m_actions.addAction(Actions.SEARCH_BALL, m_number,
						f.not(goodprediction), 
						SEARCH_BALL_CERTAINTY,
						m_memory.m_time, 0);

					m_actions.addAction(Actions.ZONE, m_number,
						f.not(zone),
						ZONE_CERTAINTY,
						m_memory.m_time, 0);

					m_actions.addAction(Actions.INTERCEPT_BALL, m_number,
					        freekickzone,
						INTERCEPT_BALL_CERTAINTY,
						m_memory.m_time, 0);
				}
			}
		}
		else 	
		{
			catchcicles = 0;
			freekickcicles = 0;
			catchball = false;

			float goodprediction 	= m_fuzzy.GoodPrediction(ball);
			float cankick 		= m_fuzzy.CanKick(ball);
			float cancatch 		= m_fuzzy.CanCatch(ball, m_memory.myX, m_memory.myY, lastcatch, m_memory.m_time);
			float canpass 		= m_fuzzy.CanPass(ball);
			float zone		= m_fuzzy.Zone(m_rol, m_memory.myX, m_memory.myY, ball);
			BallInfo f_ball = PredictBall(ball, SoccerParams.PREDICTION_CICLES);
			float influencearea	= m_fuzzy.InfluenceArea(m_rol, f_ball.m_position.X, f_ball.m_position.Y);

			m_actions.addAction(Actions.NOP, m_number,
				1,
				NOP_CERTAINTY,
				m_memory.m_time, 0);

			m_actions.addAction(Actions.SEARCH_BALL, m_number,
				f.not(goodprediction), 
				SEARCH_BALL_CERTAINTY,
				m_memory.m_time, 0);

			m_actions.addAction(Actions.ZONE, m_number,
				f.not(zone),
				ZONE_CERTAINTY,
				m_memory.m_time, 0);

			m_actions.addAction(Actions.CLEARING, m_number,
				cankick, 
				CLEARING_CERTAINTY,
				m_memory.m_time, 0);

			if ((m_playMode.compareTo("corner_kick_"+o_side) != 0)
			  &&(m_playMode.compareTo("free_kick_"+o_side) != 0)
			  &&(m_playMode.compareTo("goal_kick_"+o_side) != 0)
			  &&(m_playMode.compareTo("kick_in_"+o_side) != 0))
			{
				m_actions.addAction(Actions.INTERCEPT_BALL, m_number,
				        f.and(f.not(cankick),
					      influencearea),
					INTERCEPT_BALL_CERTAINTY,
					m_memory.m_time, 0);
			}

			m_actions.addAction(Actions.PASS, m_number,
				f.and( cankick, 
				       canpass), 
				PASS_CERTAINTY,
				m_memory.m_time, m_fuzzy.PassDir);

			m_actions.addAction(Actions.CATCH_BALL, m_number,
				cancatch, 
				CATCH_BALL_CERTAINTY,
				m_memory.m_time, ball.m_direction);
		}

		reactive_decision = m_actions.MoreCertainty(m_number);

		SendReactiveDecision(ball);
	}
}