import java.util.*;

class SeeInfo
{
	public int		m_time;
	public Vector		m_objects;
	private StringTokenizer	m_tokenizer;
	String m_info;

	public SeeInfo(String info)
	{
		m_info = info;
		info.trim();
		m_tokenizer = new StringTokenizer(info,"() ", true);
		m_objects = new Vector(100);

		parse();

//System.out.println("MISSATGE DE VISUALITZACIO");
//System.out.println(info);
//System.out.println(" ");
	}

	public SeeInfo()
	{
		m_time=-1;
		m_objects = new Vector(100);
	}

	public void parse()
	{
		String token = null;
		ObjectInfo	objInfo;

		try
		{
			m_tokenizer.nextToken();	// '('
			m_tokenizer.nextToken();	// 'see'
			m_tokenizer.nextToken();	// ' '
			m_time = Integer.parseInt( m_tokenizer.nextToken() ); // TIME
			m_tokenizer.nextToken();	// ' '
			token = m_tokenizer.nextToken();

			while(token.compareTo("(") == 0)// '('
			{
				objInfo = createNewObject();
				m_objects.addElement(objInfo);
			
				token = m_tokenizer.nextToken();
				if( token.compareTo(")") == 0 )
				{
					token = m_tokenizer.nextToken();
					if(token.compareTo(" ") == 0) token = m_tokenizer.nextToken();
					continue;
				}

				token = m_tokenizer.nextToken();

				objInfo.m_distance = Float.valueOf(token).floatValue();

				token = m_tokenizer.nextToken();

				if( token.compareTo(")") == 0 )
				{
					token = m_tokenizer.nextToken();
					if(token.compareTo(" ") == 0) token = m_tokenizer.nextToken();
					continue;
				}

				objInfo.m_direction = Float.valueOf(m_tokenizer.nextToken()).floatValue();
				token = m_tokenizer.nextToken();

				if( token.compareTo(")") == 0 )
				{
					token = m_tokenizer.nextToken();
					if(token.compareTo(" ") == 0) token = m_tokenizer.nextToken();
					continue;
				}

				objInfo.m_distChange = Float.valueOf(m_tokenizer.nextToken()).floatValue();
				token = m_tokenizer.nextToken();
				if( token.compareTo(")") == 0 )
				{
					token = m_tokenizer.nextToken();
					if(token.compareTo(" ") == 0) token = m_tokenizer.nextToken();
					continue;
				}

				objInfo.m_dirChange = Float.valueOf(m_tokenizer.nextToken()).floatValue();
				token = m_tokenizer.nextToken();

				if( token.compareTo(")") == 0 )
				{
					token = m_tokenizer.nextToken();
					if(token.compareTo(" ") == 0) token = m_tokenizer.nextToken();
					continue;
				}

				// s'hauria de guardar en el player.FaceDir
				float FaceDir = Float.valueOf(m_tokenizer.nextToken()).floatValue();
				token = m_tokenizer.nextToken();

				if( token.compareTo(")") == 0 )
				{
					token = m_tokenizer.nextToken();
					if(token.compareTo(" ") == 0) token = m_tokenizer.nextToken();
					continue;
				}

				// s'hauria de guardar en el player.HeadDir
				float HeadDir = Float.valueOf(m_tokenizer.nextToken()).floatValue();

				token = m_tokenizer.nextToken();
				token = m_tokenizer.nextToken();
				if(token.compareTo(" ") == 0) token = m_tokenizer.nextToken();
			}
		}
		catch(Exception e)
		{
			System.out.println("Error parsing see information!");
			System.out.println(token);
			while( m_tokenizer.hasMoreTokens() ) System.out.print(m_tokenizer.nextToken());
//			System.out.println(m_info);
			System.out.println("");
		}
	}

	public ObjectInfo createNewObject()
	{
		String		token = null;
		ObjectInfo	objInfo = null;
		
		m_tokenizer.nextToken();			// '('
		token = m_tokenizer.nextToken();
		if(token.compareTo("player") == 0)
		{
			String team = new String();
			int uniformNumber = 0;
			token = m_tokenizer.nextToken();	// ' '
			if(token.compareTo(" ") == 0)
			{
				team = m_tokenizer.nextToken();	// teamname
				token = m_tokenizer.nextToken();// ' '
				if(token.compareTo(" ") == 0) uniformNumber = Integer.parseInt(m_tokenizer.nextToken());	// uniform number
			}
			objInfo = new PlayerInfo(team, uniformNumber);
		}
		else if(token.compareTo("goal") == 0)
		{
			token = m_tokenizer.nextToken();	// space
			if(token.compareTo(" ") == 0) token = m_tokenizer.nextToken();	// side
			objInfo = new GoalInfo(token.charAt(0));
		}
		else if(token.compareTo("ball") == 0)
		{
			objInfo = new BallInfo();
		}
		else if(token.compareTo("flag") == 0)
		{
			char type = ' ';
			char pos1 = ' ';
			char pos2 = ' ';
			int num = 0;
			boolean out = true;

			token = m_tokenizer.nextToken();	// space
			token = m_tokenizer.nextToken();	// p or g or [l|c|r] or [b|t]
			if(( token.compareTo("p") == 0 )||( token.compareTo("g") == 0 ))
			{
				type = token.charAt(0);
				token = m_tokenizer.nextToken();	// space
				token = m_tokenizer.nextToken();	// [l|r]
				pos1 = token.charAt(0);
				token = m_tokenizer.nextToken();	// space
				token = m_tokenizer.nextToken();	// [t|c|b]
				pos2 = token.charAt(0);
				out = false;
			}
			else if(( token.compareTo("l") == 0 )||( token.compareTo("r") == 0 ))
			{
				pos1 = token.charAt(0);
				token = m_tokenizer.nextToken();	// space
				token = m_tokenizer.nextToken();	// [t|b] or 0
				pos2 = token.charAt(0);

				if (pos2 == '0')  
				{
					num=0;
					pos2=' ';
					out=true;
				}
				else
				{
					token = m_tokenizer.nextToken(); 	// space or )

					if ( token.compareTo(")") == 0 ) out=false;
					else 
					{
						num = Integer.parseInt( m_tokenizer.nextToken() );
						out=true;
					}
				}
			}
			else if( token.compareTo("c") == 0 )
			{
				pos1 = token.charAt(0);
				token = m_tokenizer.nextToken();	// ) or space
				if ( token.compareTo(")") != 0)
				{
					token = m_tokenizer.nextToken();	// [t|b]
					pos2 = token.charAt(0);
				}
				out=false;
			}
			else if(( token.compareTo("b") == 0 )||( token.compareTo("t") == 0 ))
			{
				pos1 = token.charAt(0);
				token = m_tokenizer.nextToken();	// space
				token = m_tokenizer.nextToken();	// [r|l] or 0
				pos2 = token.charAt(0);

				if ( pos2 == '0')
				{
					pos2=' ';
					num=0;
				}
				else
				{
					token = m_tokenizer.nextToken();			// space
					num = Integer.parseInt(m_tokenizer.nextToken());	// number
					token = m_tokenizer.nextToken();			// )
				}
				out=true;
			}

			objInfo = new FlagInfo(type, pos1, pos2, num, out);
		}
		else if(token.compareTo("line") == 0)
		{
			token = m_tokenizer.nextToken();	// space
			token = m_tokenizer.nextToken();	// [l|r|t|b]
			objInfo = new LineInfo(token.charAt(0));
		}
		else if(token.compareTo("Player") == 0)
		{
			objInfo = new PlayerInfo();
		}
		else if(token.compareTo("Goal") == 0)
		{
			objInfo = new GoalInfo();
		}
		else if(token.compareTo("Ball") == 0)
		{
			objInfo = new BallInfo();
		}
		else if(token.compareTo("Flag") == 0)
		{
			objInfo = new FlagInfo();
		}
		else if(token.compareTo("Line") == 0)
		{
			objInfo = new LineInfo();
		}

		if(token.compareTo(")") != 0) token = m_tokenizer.nextToken();	

		return objInfo;
	}

	public ObjectInfo getObject(String name) 
	{
		for(int c = 0 ; c < m_objects.size() ; c ++)
		{
			ObjectInfo object = (ObjectInfo)m_objects.elementAt(c);
			if(object.m_type.compareTo(name) == 0) return object;
		}												 
		
		return null;
	}

	public PlayerInfo getPlayer(String team, int number) 
	{
		for(int c = 0 ; c < m_objects.size() ; c ++)
		{
			ObjectInfo object = (ObjectInfo)m_objects.elementAt(c);
			if(object.m_type.compareTo("player") == 0) 
			{
				PlayerInfo player = (PlayerInfo)object;

				if ((player.m_team != null)&&(team != null))
				{
					if ((player.m_team.compareTo(team) == 0)&&(player.m_number == number)) return player;
				}
			}
		}												 
		
		return null;
	}

	public FlagInfo getFlag(char type, char pos1, char pos2) 
	{
		for(int c = 0 ; c < m_objects.size() ; c ++)
		{
			ObjectInfo object = (ObjectInfo)m_objects.elementAt(c);
			if(object.m_type.compareTo("flag") == 0) 
			{
				FlagInfo flag = (FlagInfo)object;

				if ((flag.m_type2 == type)&&(flag.m_pos1 == pos1)&&(flag.m_pos2 == pos2)) return flag;
			}
		}	

		return null;
	}

	public void removeObject(String name)
	{
		for(int c = 0 ; c < m_objects.size() ; c ++)
		{
			ObjectInfo object = (ObjectInfo)m_objects.elementAt(c);
			if(object.m_type.compareTo(name) == 0) m_objects.removeElementAt(c);
		}
	}

	public int getIndex(String name) 
	{
		for(int c = 0 ; c < m_objects.size() ; c ++)
		{
			ObjectInfo object = (ObjectInfo)m_objects.elementAt(c);
			if(object.m_type.compareTo(name) == 0) return c;
		}	

		return -1;											 
	}

	public int getIndexPlayer(String team, int number) 
	{
		for(int c = 0 ; c < m_objects.size() ; c ++)
		{
			ObjectInfo object = (ObjectInfo)m_objects.elementAt(c);
			if(object.m_type.compareTo("player") == 0) 
			{
				PlayerInfo player = (PlayerInfo)object;
				if ((player.m_team == team)&&(player.m_number == number)) return c;
			}
		}	

		return -1;											 
	}

	public void print()
	{
		System.out.println("SIZE="+m_objects.size());

		for(int c = 0 ; c < m_objects.size() ; c ++)
		{
			ObjectInfo object = (ObjectInfo)m_objects.elementAt(c);
			object.print();
		}	
		System.out.println(" ");
	}
}
