import java.io.*;
import java.net.*;
import java.util.StringTokenizer;

class SendSoccerServer
{
	public rogi2		m_rogi2;
	public DatagramSocket	m_socket;
	public InetAddress	m_host;	
	public int		m_port;
	public int		m_number;
	public String		m_team;
	public boolean 		m_goalie;
	public String		command;

	public SendSoccerServer(rogi2 r2, DatagramSocket socket, InetAddress host, int port, String team, boolean goalie, boolean reconnect, int number)
	{
		m_socket = socket;
		m_rogi2 = r2;
		m_host = host;
		m_port = port;
		m_number = number;
		m_team = team;
		m_goalie = goalie;
		command = "";

		try
		{
			InitCommand(team, goalie, reconnect, number);

			parseInitCommand(receive());
		}
		catch (Exception e)
		{
			System.err.println("socket error " + e);
		}
	}

	public void InitCommand(String team, boolean goalie, boolean reconnect, int number)
	{
		if (reconnect)
		{
			send("(reconnect " + team + " " + number+")");

		}
		else
		{
			if (goalie) send("(init " + team + " (version 5.00) (goalie))");
			else send("(init " + team + " (version 5.00))");
		}
	}

	public void parseInitCommand(String message) throws IOException
	{ 
		char side = ' ';
		String playMode = null;

		StringTokenizer	tokenizer = new StringTokenizer(message,"() ");
		String token = tokenizer.nextToken();		

		if( token.compareTo("init") == 0)
		{
			side = tokenizer.nextToken().charAt(0);
			m_number = Integer.parseInt(tokenizer.nextToken());
			playMode = tokenizer.nextToken();
		}
		else if( token.compareTo("reconnect") == 0)
		{
			side = tokenizer.nextToken().charAt(0);
			playMode = tokenizer.nextToken();
			if (m_number == 1) m_goalie = true;
		}
		else
		{
			throw new IOException(message);
		}


		m_rogi2.InitBrain(side, m_number, playMode, m_team, m_goalie);
	}

	public void send()
	{
		send(command);
	}

	public void send(String message)
	{
		byte[] buffer = message.getBytes();
		DatagramPacket packet = new DatagramPacket(buffer, buffer.length, m_host, m_port);

		try
		{
			m_socket.send(packet);
		}
		catch(IOException e)
		{
			System.err.println("socket sending error " + e);
		}
	}

	public String receive() 
	{
		byte[] buffer = new byte[SoccerParams.SOCCERSERVER_MSG_SIZE];
		DatagramPacket packet = new DatagramPacket(buffer, SoccerParams.SOCCERSERVER_MSG_SIZE);

		try
		{
			m_socket.receive(packet);

			m_port = packet.getPort();
		}
		catch(IOException e)
		{
			System.err.println("socket receiving error " + e);
		}
		return new String(buffer);
	}
}