import java.util.*;

class SenseBodyInfo
{
	public float 	stamina=0;
	public float 	effort=0;
	public float	speed=0;
	public float	head_angle=0;

	private StringTokenizer	m_tokenizer;

	public SenseBodyInfo(String info)
	{
		info.trim();
		m_tokenizer = new StringTokenizer(info,"() ", true);

		parse();
	}

	public SenseBodyInfo()
	{
		stamina=0;
		effort=0;
		speed=0;
		head_angle=0;
	}

	public void parse()
	{
		String token = null;

		try
		{
			m_tokenizer.nextToken();	// '('
			m_tokenizer.nextToken();	// 'sense_body'
			m_tokenizer.nextToken();	// ' '
			m_tokenizer.nextToken();	// TIME
			m_tokenizer.nextToken();	// ' '
			m_tokenizer.nextToken();	// '('
			m_tokenizer.nextToken();	// 'view_mode'
			m_tokenizer.nextToken();	// ' '
			m_tokenizer.nextToken();	// 'high | low'
			m_tokenizer.nextToken();	// ' '
			m_tokenizer.nextToken();	// 'narrow | normal | wide'
			m_tokenizer.nextToken();	// ')'
			m_tokenizer.nextToken();	// ' '
			m_tokenizer.nextToken();	// '('
			m_tokenizer.nextToken();	// 'stamina'
			m_tokenizer.nextToken();	// ' '
			stamina=Float.valueOf(m_tokenizer.nextToken()).floatValue();	// STAMINA
			m_tokenizer.nextToken();	// ' '
			effort=Float.valueOf(m_tokenizer.nextToken()).floatValue();	// EFFORT
			m_tokenizer.nextToken();	// ')'
			m_tokenizer.nextToken();	// ' '
			m_tokenizer.nextToken();	// '('
			m_tokenizer.nextToken();	// 'speed'
			m_tokenizer.nextToken();	// ' '
			speed=Float.valueOf(m_tokenizer.nextToken()).floatValue();	// AMOUNT_OF_SPEED
			m_tokenizer.nextToken();	// ')'
			m_tokenizer.nextToken();	// ' '
			m_tokenizer.nextToken();	// '('
			if (m_tokenizer.nextToken()=="head_angle")	// 'head_angle'
			{
				m_tokenizer.nextToken();	// ' '
				head_angle=Float.valueOf(m_tokenizer.nextToken()).floatValue(); // ANGLE
				m_tokenizer.nextToken();	// ')'
				m_tokenizer.nextToken();	// ' '
				m_tokenizer.nextToken();	// '('
			}
			m_tokenizer.nextToken();	// 'kick'
			m_tokenizer.nextToken();	// ' '
			m_tokenizer.nextToken();	// KICK_COUNT
			m_tokenizer.nextToken();	// ')'
			m_tokenizer.nextToken();	// ' '
			m_tokenizer.nextToken();	// '('
			m_tokenizer.nextToken();	// 'dash'
			m_tokenizer.nextToken();	// ' '
			m_tokenizer.nextToken();	// DASH_COUNT
			m_tokenizer.nextToken();	// ')'
			m_tokenizer.nextToken();	// ' '
			m_tokenizer.nextToken();	// '('
			m_tokenizer.nextToken();	// 'turn'
			m_tokenizer.nextToken();	// ' '
			m_tokenizer.nextToken();	// TURN_COUNT
			m_tokenizer.nextToken();	// ')'
			m_tokenizer.nextToken();	// ' '
			m_tokenizer.nextToken();	// '('
			m_tokenizer.nextToken();	// 'say'
			m_tokenizer.nextToken();	// ' '
			m_tokenizer.nextToken();	// SAY_COUNT
			m_tokenizer.nextToken();	// ')'
			if ((m_tokenizer.nextToken()==" ")&&(m_tokenizer.nextToken()=="("))	// '('
			{
				m_tokenizer.nextToken();	// 'turn_neck'
				m_tokenizer.nextToken();	// ' '
				m_tokenizer.nextToken();	// ANGLE
				m_tokenizer.nextToken();	// ')'
				m_tokenizer.nextToken();	// ')'
			}
		}
		catch(Exception e)
		{
			System.out.println("Error parsing sense_body information");
			System.out.println(token);
			while( m_tokenizer.hasMoreTokens() ) System.out.print(m_tokenizer.nextToken());

			System.out.println("");
		}
	}

}
