import java.io.*;
import java.net.*;

class rogi2 
{
	public int		m_number;
	public Brain		m_brain;	
	public SeeInfo		m_info;
	public Timer		timer;			// thread to mark the cicles
	public HearSoccerServer m_hearsoccerserver;	// thread to hear the SoccerServer messages
	public SendSoccerServer	m_sendsoccerserver;	// object to send messages to the SoccerServer
	public HearPlayers	m_hearplayers;		// thread to hear the other players messages
	public SendPlayers	m_sendplayers;		// object to send messages to the other players
	public int		local_goals;
	public int		visitant_goals;

	public static void main(String a[])
	{
		String  team = "RoGi_2_Team";
		boolean goalie = false;
		boolean reconnect = false;
		int number = 0;
		int goals1 = 0;
		int goals2 = 0;
		String	hostName = "";
		int	port = SoccerParams.SOCCERSERVER_PORT;

		try
		{	
			int c = 0;
			while (c < a.length)
			{
				if( a[c].compareTo("-host") == 0 )
				{
					hostName = a[c+1];
				}
				else if( a[c].compareTo("-port") == 0 )
				{
					port = Integer.parseInt(a[c+1]);
				}
				else if( a[c].compareTo("-team") == 0 )
				{
					team = a[c+1];
				}
				else if( a[c].compareTo("-goalie") == 0 )
				{
					goalie = true;
				}
				else if( a[c].compareTo("-reconnect") == 0 )
				{
					reconnect = true;
					number = Integer.parseInt(a[c+1]);
					goals1 = Integer.parseInt(a[c+2]);
					goals2 = Integer.parseInt(a[c+3]);
					c +=2;
				}
				else
				{
					throw new Exception();
				}
				c += 2;
			}
		}
		catch(Exception e)
		{
			System.err.println("");
			System.err.println("USAGE: rogi2 [-parameter value]");
			System.err.println("");
			System.err.println("    Parameters      value                   default");
			System.err.println("   --------------------------------------------------");
			System.err.println("    host            host_name               localhost");
			System.err.println("    port            port_number             6000");
			System.err.println("    team            team_name               rogi2");
			System.err.println("    reconnect       number goals1 goals2    2  0  0");
			System.err.println("");
			System.err.println("    Example:");
			System.err.println("      rogi2 -host www.host.com -port 6000 -team dreamteam");
			System.err.println("    or");
			System.err.println("      rogi2 -host 193.117.005.223");
			return;
		}

		try
		{
			InetAddress h = InetAddress.getByName(hostName);
			rogi2 player = new rogi2(h, port, team, goalie, reconnect, number, goals1, goals2);
		}
		catch (Exception e)
		{
			System.out.println("Error - Adrea del host no trobada !");
		}
	}  

	public rogi2(InetAddress host, int port, String team, boolean goalie, boolean reconnect, int number, int goals1, int goals2)
	{
		m_info = null;
		local_goals = goals1;
		visitant_goals = goals2;

		StartSoccerServerComunication(host, port, team, goalie, reconnect, number);
		StartPlayersComunication();
		CreateTimerThread();
	}

	public void CreateTimerThread()
	{
		timer = new Timer(this);
	}
																 
	public void StartSoccerServerComunication(InetAddress host, int port, String team, boolean goalie, boolean reconnect, int number)
	{
		try
		{
			DatagramSocket socket = new DatagramSocket();

			m_sendsoccerserver = new SendSoccerServer(this, socket, host, port, team, goalie, reconnect, number);
			m_hearsoccerserver = new HearSoccerServer(this, socket);
		}
		catch (Exception e)
		{
			System.out.println(e.getMessage());
			System.out.println("Error crear al un socket amb el SoccerServer !");
		}
	}

	public void StartPlayersComunication()
	{
		m_sendplayers = new SendPlayers(m_number);
		m_hearplayers = new HearPlayers(this, m_number);
	}

	public void Say(String message, int receiver)
	{
		m_sendplayers.say(message, receiver);
	}

	public void TakeReactiveDecision()
	{
		m_brain.UpdateMemory(m_info);			// update the my memory with the visual information
		m_info=null;

		m_brain.TakeReactiveDecision();			// take a reactive decision
	}

	public void TakeDeliberativeDecision()
	{
		m_brain.TakeDeliberativeDecision();		// take a deliberative decision

		m_sendsoccerserver.send();			// send the command to the SoccerServer
	}

	public void InitBrain(char side, int number, String playMode, String team, boolean goalie)
	{
		m_number = number;

		System.out.println("################################");
		System.out.println("   Team     = "+team);
		System.out.println("   Number   = "+number);
		if (goalie) System.out.println("   Goalie     ");
		System.out.println("   Side     = "+side);
		System.out.println("   PlayMode = "+playMode);
		System.out.println("################################");

		m_brain = new Brain(this, team, side, number, playMode, local_goals, visitant_goals);
	}

	public void move(double x, double y)
	{
		m_sendsoccerserver.command = "(move " + Double.toString(x) + " " + Double.toString(y) + ")";
	}

	public void turn(double moment)
	{
		if (moment != 0) m_sendsoccerserver.command = "(turn " + Double.toString(moment) + ")";
	}

	public void dash(double power)
	{
		if (power != 0) m_sendsoccerserver.command = "(dash " + Double.toString(power) + ")";
	}

	public void kick(double power, double direction)
	{
		if (power != 0) m_sendsoccerserver.command = "(kick " + Double.toString(power) + " " + Double.toString(direction) + ")";
	}

	public void say(String message)
	{
		m_sendsoccerserver.command = "(say " + message + ")";
	}

	public void Catch(double moment)
	{
		m_sendsoccerserver.command = "(catch " + moment + ")";
	}

	public void sensebody()
	{
		m_sendsoccerserver.command = "(sense_body)";
	}

	public void changeView(String angle, String quality)
	{
		m_sendsoccerserver.command = "(change_view " + angle + " " + quality + ")";
	}
}
